bits 16
org 0
start: jmp main

	bpbOEM			db "GZistemB"
	bpbBytesPerSector:  	dw 512 ;11 12
	bpbSectorsPerCluster: 	db 1 ;13 
	bpbReservedSectors: 	dw 1 ;14 15
	bpbNumberOfFATs: 	db 2 ;16
	bpbRootEntries: 	dw 224 ;17 18
	bpbTotalSectors: 	dw 2880 ;19
	bpbMedia: 		db 0xf0 ;21
	bpbSectorsPerFAT: 	dw 9 ;22
	bpbSectorsPerTrack: 	dw 18 ;24
	bpbHeadsPerCylinder: 	dw 2 ;26
	bpbHiddenSectors: 	dd 0 ;28
	bpbTotalSectorsBig:     dd 0 ;32
	bsDriveNumber: 	        db 0 ;36
	bsUnused: 		db 0 ;37
	bsExtBootSignature: 	db 0x29 ;38
	bsSerialNumber:	        dd 0xa0a1a2a3 ;42
	bsVolumeLabel: 	        db "GZISTEMCARO"
	bsFileSystem: 	        db "FAT12   "

	datasector   dw 0x0000
	cluster      dw 0x0000
	ImageName    db "KERNEL  BIN"
	MessageLoading db ".",0

cpu_gdt_table:
	dw 23
	dd cpu_gdt_table+0x7c00
	dw 0x0000
	dd 0x0000ffff
	dd 0x00cf9a00
	dd 0x0000ffff
	dd 0x00cf9200

%include "stdio.inc"
%include "floppy.inc"

main:
	cli	
	mov ax, 0x07C0	
	mov ds, ax
	mov es, ax
	mov fs, ax
	mov gs, ax
	mov ss, ax
	mov sp, 0xFFFF

	lgdt [ds:cpu_gdt_table]

	in al, 0x92
	or al, 2
	out 0x92, al

	mov [bsDriveNumber], dl

loadroot:         
	xor cx, cx
	xor dx, dx
	mov ax, 0x0020            
	mul WORD [bpbRootEntries] 
	div WORD [bpbBytesPerSector]
	xchg ax, cx
              
	mov al, BYTE [bpbNumberOfFATs]   
	mul WORD [bpbSectorsPerFAT]      
	add ax, WORD [bpbReservedSectors]
	mov WORD [datasector], ax      
	add WORD [datasector], cx
    
	mov bx, 0x0200
	call ReadSectors
	mov cx, WORD [bpbRootEntries] 
	mov di, 0x0200   

	mov si, MessageLoading
	call print

searchloop:
	push cx
	mov cx, 0x000B   
	mov si, ImageName
	push di
     	rep cmpsb              
	pop di
	je load_fat
	pop cx
	add di, 0x0020 
	loop searchloop
	jmp failure

load_fat: 
	mov dx, WORD [di + 0x001A]
	mov WORD [cluster], dx

	xor ax, ax
	mov al, BYTE [bpbNumberOfFATs]
	mul WORD [bpbSectorsPerFAT]
	mov cx, ax

	mov ax, WORD [bpbReservedSectors]

	mov bx, 0x0200
	call ReadSectors

	mov ax, 0x0050
	mov es, ax
	mov bx, 0x0000
	push bx

load_image:
	mov si, MessageLoading
	call print

	mov ax, WORD [cluster]             
	pop bx                             
	call ClusterLBA                     
	xor cx, cx
	mov cl, BYTE [bpbSectorsPerCluster]
	call ReadSectors
	push bx        

     	mov ax, WORD [cluster]   
	mov cx, ax               
	mov dx, ax               
	shr dx, 0x0001           
	add cx, dx               
	mov bx, 0x0200           
	add bx, cx               
	mov dx, WORD [bx]        
	test ax, 0x0001
	jnz odd
          
even:
	and dx, 0xFFF
	jmp done
         
odd:    
	shr dx, 0x0004        
          
done:
	mov WORD [cluster], dx
	cmp dx, 0x0FF0 
	jb load_image	
          
	mov ax,1112h
	xor bl,bl
	int 10h

	mov ah,01 
	mov cx,0x0606
	int 10h    

	mov eax, cr0
	or al, 1
	mov cr0, eax
	jmp 8:pmode+0x7c00
          
failure:
	mov ah, 0x00
	int 0x16
	int 0x19

bits 32
pmode:
	mov eax, 16
	mov ds, eax
	mov es, eax
	mov fs, eax
	mov gs, eax
	mov ss, eax
	mov esp, 0x90000
	jmp DWORD 0x8:0x500

times 510-($-$$) db 0
dw 0xAA55

