//GZboot FAT12 Driver
//Made by gzaloprgm

extern char* floppy_dmabuf;
unsigned int hpc=2,spt=18,sector,track,head,frs,lasttrack=0xFFFFFFFF;

void lbachs(unsigned int logical_sector){
	track = logical_sector / (hpc * spt);
	unsigned int temp =  logical_sector % (hpc * spt);
	head = temp / spt;
	sector = temp % spt + 1;
}

unsigned int chslba(unsigned int c){
	return c-2+frs;
}

void read(unsigned int logical_sector, unsigned int sectors_count, unsigned char* buffer){
	unsigned int i;
	for(i=0;i<sectors_count;i++){
		lbachs(logical_sector+i);
		if(track != lasttrack){
			floppy_read_track(0x03f0,track);
			lasttrack=track;	
		}
		unsigned int offset = (sector-1)*512 + head*spt*512;
		memcpy(buffer+512*i,floppy_dmabuf+offset,512);
	}
}
extern showloadmsg();
void loadkernel(){	
	unsigned char* bootsector = kmalloc(512);
	read(0,1,bootsector);
	unsigned char bpbNumberOfFATs = bootsector[16];
	unsigned short bpbSectorsPerFAT = bootsector[22] | bootsector[23] << 8;
	unsigned short bpbReservedSectors = bootsector[14] | bootsector[15] << 8;
	unsigned short bpbRootEntries = bootsector[17] | bootsector[18] << 8;
	unsigned char bpbSectorsPerCluster = bootsector[13];

	unsigned int rdirlocation = bpbNumberOfFATs * bpbSectorsPerFAT + bpbReservedSectors;
	unsigned int rdirlenght = (32 * bpbRootEntries) / 512;
	frs = rdirlocation+rdirlenght;
	unsigned char* rootdir = kmalloc(rdirlenght*512);
	read(rdirlocation,rdirlenght,rootdir);	

	int i = rdirlenght;
	unsigned int ptr=0;
	
	unsigned int FATsize = bpbNumberOfFATs * bpbSectorsPerFAT;
	unsigned int FATlocation = bpbReservedSectors;
	unsigned char* fat = kmalloc(FATsize*512);
	read(FATlocation,FATsize,fat);
	extern vga_largo;

	while(i>=0){
		unsigned int fcluster = rootdir[ptr+0x1A] | rootdir[ptr+0x1B] << 8;
		unsigned int fsize = rootdir[ptr+0x1C] | rootdir[ptr+0x1D] << 8 | rootdir[ptr+0x1E] << 16 | rootdir[ptr+0x1F] << 24 ;
		if(rootdir[ptr] != '\0'){
			puts("File Name: "); put(rootdir+ptr,11); puts("\n");
			puts("First Clu: "); puti(fcluster); puts("\n");
			puts("File Size: "); puti(fsize); puts("\n");
			if(strequ(rootdir+ptr,"NEXT    BIN",11)){
				//vga_largo = fsize;
				showloadmsg();
				puts("Contents : ");
				unsigned char* file = kmalloc(512);
				unsigned int finish = 0;
				unsigned int cluster = fcluster;
				unsigned int t = 0x100000;
				while(finish == 0){
					//addbarra();
					read(chslba(cluster),1,t);
					t+=512;
					//put(file,512);
					unsigned int index = cluster + cluster/2;
					unsigned int tmp = fat[index] | fat [index+1] << 8;
					if(cluster%2==0){	
						cluster = tmp & 0xFFF;
					}else{
						cluster = tmp >> 4;
					}
					if(cluster>0x0FF0) finish=1;

				}
				goback();
				asm volatile("call 0x100000");
			}
			puts("\n");
		}
		ptr+=32;
		i--;
	}
	
}
