//GZboot IDT set up
//Made by gzaloprgm

struct idt_entry_struct{
   	unsigned short base_lo;
	unsigned short sel;
	unsigned char  always0;
	unsigned char  flags;
	unsigned short base_hi;
} __attribute__((packed));
typedef struct idt_entry_struct idt_entry_t;

struct idt_ptr_struct{
   	unsigned short limit;
  	unsigned int base;
} __attribute__((packed));
typedef struct idt_ptr_struct idt_ptr_t;

extern void idt_flush(unsigned int);

extern void isr0 ();
extern void isr1 ();
extern void isr2 ();
extern void isr3 ();
extern void isr4 ();
extern void isr5 ();
extern void isr6 ();
extern void isr7 ();
extern void isr8 ();
extern void isr9 ();
extern void isr10();
extern void isr11();
extern void isr12();
extern void isr13();
extern void isr14();
extern void isr15();
extern void isr16();
extern void isr17();
extern void isr18();
extern void isr19();
extern void isr20();
extern void isr21();
extern void isr22();
extern void isr23();
extern void isr24();
extern void isr25();
extern void isr26();
extern void isr27();
extern void isr28();
extern void isr29();
extern void isr30();
extern void isr31();
extern void irq0 ();
extern void irq1 ();
extern void irq2 ();
extern void irq3 ();
extern void irq4 ();
extern void irq5 ();
extern void irq6 ();
extern void irq7 ();
extern void irq8 ();
extern void irq9 ();
extern void irq10();
extern void irq11();
extern void irq12();
extern void irq13();
extern void irq14();
extern void irq15();
extern void llamada();

idt_entry_t idt_entries[256];
idt_ptr_t   idt_ptr;

static void idt_set_gate(unsigned char num, unsigned int base, unsigned short sel, unsigned char flags){
   	idt_entries[num].base_lo = base & 0xFFFF;
   	idt_entries[num].base_hi = (base >> 16) & 0xFFFF;

	idt_entries[num].sel     = sel;
	idt_entries[num].always0 = 0;
	idt_entries[num].flags   = flags ;
}

void init_idt(){
	outportb(0x20, 0x11);
	outportb(0xA0, 0x11);
	outportb(0x21, 0x20);
	outportb(0xA1, 0x28);
	outportb(0x21, 0x04);
	outportb(0xA1, 0x02);
	outportb(0x21, 0x01);
	outportb(0xA1, 0x01);
	outportb(0x21, 0x0);
	outportb(0xA1, 0x0);

   	idt_ptr.limit = sizeof(idt_entry_t) * 256 -1;
	idt_ptr.base  = (unsigned int)&idt_entries;

	idt_set_gate( 0, (unsigned int)isr0 , 0x08, 0xEE);
	idt_set_gate( 1, (unsigned int)isr1 , 0x08, 0xEE);
	idt_set_gate( 2, (unsigned int)isr2 , 0x08, 0xEE);
	idt_set_gate( 3, (unsigned int)isr3 , 0x08, 0xEE);
   	idt_set_gate( 4, (unsigned int)isr4 , 0x08, 0xEE);
	idt_set_gate( 5, (unsigned int)isr5 , 0x08, 0xEE);
	idt_set_gate( 6, (unsigned int)isr6 , 0x08, 0xEE);
	idt_set_gate( 7, (unsigned int)isr7 , 0x08, 0xEE);
	idt_set_gate( 8, (unsigned int)isr8 , 0x08, 0xEE);
	idt_set_gate( 9, (unsigned int)isr9 , 0x08, 0xEE);
	idt_set_gate(10, (unsigned int)isr10, 0x08, 0xEE);
	idt_set_gate(11, (unsigned int)isr11, 0x08, 0xEE);
	idt_set_gate(12, (unsigned int)isr12, 0x08, 0xEE);
	idt_set_gate(13, (unsigned int)isr13, 0x08, 0xEE);
	idt_set_gate(14, (unsigned int)isr14, 0x08, 0xEE);
	idt_set_gate(15, (unsigned int)isr15, 0x08, 0xEE);
	idt_set_gate(16, (unsigned int)isr16, 0x08, 0xEE);
	idt_set_gate(17, (unsigned int)isr17, 0x08, 0xEE);
	idt_set_gate(18, (unsigned int)isr18, 0x08, 0xEE);
	idt_set_gate(19, (unsigned int)isr19, 0x08, 0xEE);
	idt_set_gate(20, (unsigned int)isr20, 0x08, 0xEE);
	idt_set_gate(21, (unsigned int)isr21, 0x08, 0xEE);
	idt_set_gate(22, (unsigned int)isr22, 0x08, 0xEE);
	idt_set_gate(23, (unsigned int)isr23, 0x08, 0xEE);
	idt_set_gate(24, (unsigned int)isr24, 0x08, 0xEE);
	idt_set_gate(25, (unsigned int)isr25, 0x08, 0xEE);
	idt_set_gate(26, (unsigned int)isr26, 0x08, 0xEE);
	idt_set_gate(27, (unsigned int)isr27, 0x08, 0xEE);
	idt_set_gate(28, (unsigned int)isr28, 0x08, 0xEE);
	idt_set_gate(29, (unsigned int)isr29, 0x08, 0xEE);
	idt_set_gate(30, (unsigned int)isr30, 0x08, 0xEE);
	idt_set_gate(31, (unsigned int)isr31, 0x08, 0xEE);
	idt_set_gate(32, (unsigned int)irq0, 0x08, 0xEE);
	idt_set_gate(33, (unsigned int)irq1, 0x08, 0xEE);
	idt_set_gate(34, (unsigned int)irq2, 0x08, 0xEE);
	idt_set_gate(35, (unsigned int)irq3, 0x08, 0xEE);
	idt_set_gate(36, (unsigned int)irq4, 0x08, 0xEE);
	idt_set_gate(37, (unsigned int)irq5, 0x08, 0xEE);
	idt_set_gate(38, (unsigned int)irq6, 0x08, 0xEE);
	idt_set_gate(39, (unsigned int)irq7, 0x08, 0xEE);
	idt_set_gate(40, (unsigned int)irq8, 0x08, 0xEE);
	idt_set_gate(41, (unsigned int)irq9, 0x08, 0xEE);
	idt_set_gate(42, (unsigned int)irq10, 0x08, 0xEE);
	idt_set_gate(43, (unsigned int)irq11, 0x08, 0xEE);
	idt_set_gate(44, (unsigned int)irq12, 0x08, 0xEE);
	idt_set_gate(45, (unsigned int)irq13, 0x08, 0xEE);
	idt_set_gate(46, (unsigned int)irq14, 0x08, 0xEE);
	idt_set_gate(47, (unsigned int)irq15, 0x08, 0xEE);
	
	idt_flush((unsigned int)&idt_ptr);
}

