//GZboot ISR/IRQ handler
//Made by gzaloprgm

typedef struct registers{
    	unsigned int ds;
	unsigned int edi, esi, ebp, esp, ebx, edx, ecx, eax;
	unsigned int int_no, err_code;
	unsigned int eip, cs, eflags, useresp, ss;
} registers_t;

typedef void (*isr_t)(registers_t);
isr_t interrupt_handlers[256];
unsigned char waitlist[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

void register_interrupt_handler(unsigned char n, isr_t handler){
    	interrupt_handlers[n] = handler;
}

void irq_handler(registers_t regs){
	if (regs.int_no >= 40){
        	outportb(0xA0, 0x20);
    	}
    	outportb(0x20, 0x20);

	if (interrupt_handlers[regs.int_no] != 0){
        	isr_t handler = interrupt_handlers[regs.int_no];
	        handler(regs);
	}
	waitlist[regs.int_no-32] = 1;
}

void isr_handler(registers_t regs){
	if(interrupt_handlers[regs.int_no] != 0){
		isr_t handler = interrupt_handlers[regs.int_no];
	        handler(regs);
		return;
	}	
	for(;;);
}

void irq_wait(unsigned int irq){
	while(waitlist[irq] == 0);
	waitlist[irq] = 0;
}
