//GZboot multi tasking
//Made by gzaloprgm

typedef struct process_s{
	unsigned int stack;
	unsigned int state;
	unsigned int ticks;
}process_t;

volatile unsigned int current_task=0;
volatile unsigned int tasks=1;
volatile unsigned int tick = 0;
process_t task[4];

void next_esp(){
	current_task++;
	if(current_task>=tasks) current_task = 0;
}

unsigned int scheduler(unsigned int esp){
	tick++;
	task[current_task].stack = esp;

	do{
		next_esp();	
	}while(task[current_task].state!=1 && current_task!=0);
	
	task[current_task].ticks++;
	return task[current_task].stack;
}

void init_tasking(){
	task[0].state = 1;
}

void died(){
	task[current_task].state = 0;
	while(1);
}

void addtask(void (*eip)()){
	asm volatile("cli");
	unsigned int a = kmalloc(4096) + 4096;

	unsigned int* stack = (unsigned int*) a;
	*--stack = (unsigned int)died;	
	*--stack = 0x202;	
	*--stack = 0x08;	
	*--stack = (unsigned int)eip;	

	*--stack = 0;
	*--stack = 0;	
	*--stack = 0;	
	*--stack = 0;	
	*--stack = 0;	
	*--stack = 0;	
	*--stack = 0;	
	*--stack = 0;	

	*--stack = 0x10;	
	*--stack = 0x10;	
	*--stack = 0x10;	
	*--stack = 0x10;		
	*--stack = 0x10;	
	
	task[tasks].state=1;
	task[tasks++].stack = (unsigned int)stack;
	asm volatile("sti");
}

void sleep(unsigned int milliseconds){
	unsigned int total = tick + milliseconds;
	while(tick<total);
}

void init_timer(unsigned int hz){
	int divisor = 1193180 / hz;
	outportb(0x43, 0x36);
	outportb(0x40, divisor & 0xFF);
	outportb(0x40, divisor >> 8);
}
