//GZboot vga driver
//Made by Chris Giese (Mode13 y 90x60 text mode)
//and gzaloprgm (font, bmp loading and logo)

#define	VGA_AC_INDEX		0x3C0
#define	VGA_AC_WRITE		0x3C0
#define	VGA_AC_READ		0x3C1
#define	VGA_MISC_WRITE		0x3C2
#define VGA_SEQ_INDEX		0x3C4
#define VGA_SEQ_DATA		0x3C5
#define	VGA_DAC_READ_INDEX	0x3C7
#define	VGA_DAC_WRITE_INDEX	0x3C8
#define	VGA_DAC_DATA		0x3C9
#define	VGA_MISC_READ		0x3CC
#define VGA_GC_INDEX 		0x3CE
#define VGA_GC_DATA 		0x3CF
#define VGA_CRTC_INDEX		0x3D4
#define VGA_CRTC_DATA		0x3D5
#define	VGA_INSTAT_READ		0x3DA

#define	VGA_NUM_SEQ_REGS	5
#define	VGA_NUM_CRTC_REGS	25
#define	VGA_NUM_GC_REGS		9
#define	VGA_NUM_AC_REGS		21
#define	VGA_NUM_REGS		(1 + VGA_NUM_SEQ_REGS + VGA_NUM_CRTC_REGS + \
				VGA_NUM_GC_REGS + VGA_NUM_AC_REGS)
unsigned char g_90x60_text[] =
{
/* MISC */
	0xE7,
/* SEQ */
	0x03, 0x01, 0x03, 0x00, 0x02,
/* CRTC */
	0x6B, 0x59, 0x5A, 0x82, 0x60, 0x8D, 0x0B, 0x3E,
	0x00, 0x47, 0x06, 0x07, 0x00, 0x00, 0x00, 0x00,
	0xEA, 0x0C, 0xDF, 0x2D, 0x08, 0xE8, 0x05, 0xA3,
	0xFF,
/* GC */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0E, 0x00,
	0xFF,
/* AC */
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x14, 0x07,
	0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
	0x0C, 0x00, 0x0F, 0x08, 0x00,
};

unsigned char g_320x200x256[] =
{
/* MISC */
	0x63,
/* SEQ */
	0x03, 0x01, 0x0F, 0x00, 0x0E,
/* CRTC */
	0x5F, 0x4F, 0x50, 0x82, 0x54, 0x80, 0xBF, 0x1F,
	0x00, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x9C, 0x0E, 0x8F, 0x28,	0x40, 0x96, 0xB9, 0xA3,
	0xFF,
/* GC */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,
	0xFF,
/* AC */
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
	0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
	0x41, 0x00, 0x0F, 0x00,	0x00
};

void write_regs(unsigned char *regs)
{
	unsigned i;

/* write MISCELLANEOUS reg */
	outportb(VGA_MISC_WRITE, *regs);
	regs++;
/* write SEQUENCER regs */
	for(i = 0; i < VGA_NUM_SEQ_REGS; i++)
	{
		outportb(VGA_SEQ_INDEX, i);
		outportb(VGA_SEQ_DATA, *regs);
		regs++;
	}
/* unlock CRTC registers */
	outportb(VGA_CRTC_INDEX, 0x03);
	outportb(VGA_CRTC_DATA, inportb(VGA_CRTC_DATA) | 0x80);
	outportb(VGA_CRTC_INDEX, 0x11);
	outportb(VGA_CRTC_DATA, inportb(VGA_CRTC_DATA) & ~0x80);
/* make sure they remain unlocked */
	regs[0x03] |= 0x80;
	regs[0x11] &= ~0x80;
/* write CRTC regs */
	for(i = 0; i < VGA_NUM_CRTC_REGS; i++)
	{
		outportb(VGA_CRTC_INDEX, i);
		outportb(VGA_CRTC_DATA, *regs);
		regs++;
	}
/* write GRAPHICS CONTROLLER regs */
	for(i = 0; i < VGA_NUM_GC_REGS; i++)
	{
		outportb(VGA_GC_INDEX, i);
		outportb(VGA_GC_DATA, *regs);
		regs++;
	}
/* write ATTRIBUTE CONTROLLER regs */
	for(i = 0; i < VGA_NUM_AC_REGS; i++)
	{
		(void)inportb(VGA_INSTAT_READ);
		outportb(VGA_AC_INDEX, i);
		outportb(VGA_AC_WRITE, *regs);
		regs++;
	}
/* lock 16-color palette and unblank display */
	(void)inportb(VGA_INSTAT_READ);
	outportb(VGA_AC_INDEX, 0x20);
}

void VgaSetColor(unsigned char color, unsigned char red, unsigned char green, unsigned char blue)
{
	outportb(0x3C8, color);
	outportb(0x3C9, red);
	outportb(0x3C9, green);
	outportb(0x3C9, blue);
}


unsigned char* v = (unsigned char*) 0xa0000;
unsigned char* buffer;
unsigned int init = 0;
unsigned int sizeoffile,inicioimg,ancho,alto;

unsigned int end;
unsigned char* logo = (unsigned char*) &end;
unsigned char* prevfont;
void mode13(){
	write_regs(g_320x200x256);
	prevfont = kmalloc(320*200);
	int i;for(i=0;i<320*200;i++) prevfont[i] = v[i];
}
void showlogo(){
	if(logo[0] != 'B' || logo[1] != 'M'){
		puts("BMP not valid.");
		return;	
	}
	int r=54,c;
	for(c=0;c<320*200;c++) v[c] = 0;
	for(c=0;c<256;c++){
		VgaSetColor(c,logo[r+2] >> 2,logo[r+1] >> 2,logo[r] >> 2);
		r+=4;
	}
	unsigned int ancho = logo[21] << 24 | logo[20] << 16 | logo[19] << 8 | logo[18];
	unsigned int alto = logo[25] << 24 | logo[24] << 16 | logo[23] << 8 | logo[22];
	unsigned int inicioimg = logo[13] << 24 | logo[12] << 16 | logo[11] << 8 | logo[10];
	unsigned int compresion = logo[33] << 24 | logo[32] << 16 | logo[31] << 8 | logo[30];
	
	if(compresion == 0){
		unsigned int x,y,t=inicioimg;
		for(y=alto;y>=0;y--){
			for(x=0;x<ancho;x++){
				v[x+320*y] = logo[t] >> 4;
				x++;
				v[x+320*y] = logo[t++] & 0xF;
			}
		}
	}
	else if(compresion == 2){
		int x=0,y=alto,t=inicioimg,val,vals;	
		#define pop() logo[t++] 
		v+=320*40;
		while(y>=0){
			x=0;
			while(x<ancho){
				val = pop();
				if(val != 0){
					vals = pop();
					while(val--){
						v[x+320*y] = vals >> 4;
						x++;
						if(val > 0){
							v[x+320*y] = vals & 0xF;
							x++;
							val--;
						}
					}
				}else{
					val = pop();
					if(val==0){
						x=ancho;
						y--;
					}else if(val==1){
						x=ancho;	
						y=-1;
					}else if(val==2){
						val = pop();
						x+=val;
						val = pop();	
						y-=val;
					}else{
						unsigned char skip;
						if( ((val&3) == 1) || ((val&3) == 2)){
							skip = 1;
						}else{
							skip = 0;
						}
						while(val--) {
							vals = pop();
							v[x+320*y] = vals >> 4;
							x++;
							if(val > 0) {
								v[x+320*y] = vals & 0xF;
								x++;
								val--;
							}
						}
						if(skip) pop();

					}
				}
			}
		}
	}
	v-=320*40;
}	

void drawrect(unsigned short x, unsigned short y, unsigned short x1, unsigned short y1, unsigned char color){
	int xt=x,yt=y;
	y1+=y;
	x1+=x;
	while(y<y1){
		x=xt;
		while(x<x1){
			if(x<320 && y<200) v[x+y*320] = color;
			x++;
		}
		y++;
	}
}

void draw(unsigned char que, unsigned short x, unsigned short y, unsigned char color){
	x+=4;
	while(que!=0){
		if(que%2 == 1) v[x+y*320] = color;
		que/=2;
		x--;
	}
}
char claves[] = {0x10,0x1F,0x11,0x1E,0x04,0x19,0x15,0x13,0x11,0x00};

void drawfull(unsigned char* fnt, unsigned short x, unsigned short y, unsigned char c){
	draw(claves[fnt[0] & 0xF],x,y+0,c);
	draw(claves[fnt[0] >> 4],x,y+1,c);
	draw(claves[fnt[1] & 0xF],x,y+2,c);
	draw(claves[fnt[1] >> 4],x,y+3,c);
	draw(claves[fnt[2] & 0xF],x,y+4,c);	
}
#define make(a,b,c,d,e) {a|b<<4,c|d<<4,e}

void printl(unsigned short x, unsigned short y, unsigned char c){
	char L[] = make(0,0,0,0,1);
	char O[] = make(1,2,2,2,1);
	char A[] = make(1,2,1,2,2);
	char D[] = make(3,2,2,2,3);
	char I[] = make(1,4,4,4,1);
	char N[] = make(2,5,6,7,2);
	char G[] = make(1,0,1,2,1);
	char Dot[] = make(9,9,9,9,4);

	drawfull(L,6*0+x,y,c);
	drawfull(O,6*1+x,y,c);
	drawfull(A,6*2+x,y,c);
	drawfull(D,6*3+x,y,c);
	drawfull(I,6*4+x,y,c);
	drawfull(N,6*5+x,y,c);
	drawfull(G,6*6+x,y,c);
	drawfull(Dot,6*7-1+x,y,c);
	drawfull(Dot,6*8-5+x,y,c);
	drawfull(Dot,6*9-9+x,y,c);
}

void showloadmsg(){
	printl(5,190,5);
	
}
int x=0; unsigned int vga_largo;

/*void addbarra(){
	unsigned int llamadas_totales = (vga_largo/512)+1;
	x++;
	drawrect(x+5,190,310/llamadas_totales,5,5);
}*/

void set_plane(unsigned p)
{
	unsigned char pmask;

	p &= 3;
	pmask = 1 << p;
	outportb(VGA_GC_INDEX, 4);
	outportb(VGA_GC_DATA, p);
	outportb(VGA_SEQ_INDEX, 2);
	outportb(VGA_SEQ_DATA, pmask);
}

void goback(){
	set_plane(2);
	int i;for(i=0;i<320*200;i++)v[i] = prevfont[i]; 
	write_regs(g_90x60_text);	
	cls_9060();
}
