//GZboot console driver
//Made by gzaloprgm

static unsigned int x=0,y=0;
static unsigned short* videomem = (unsigned short*) 0xB8000;

static void move_csr()
{
	unsigned short temp = (y * 80 + x);
	outportb(0x3D4, 14);
	outportb(0x3D5, temp >> 8);
	outportb(0x3D4, 15);
	outportb(0x3D5, temp);
}

void putch(unsigned char chr){
	if(chr==0x8){
		if(x!=0){
			x--;
			videomem[y*80+x] = ' ' | (0x7 << 8);
		}
	}else if(chr=='\n'){
		y++;
		x=0;
	}else if(chr=='\r'){
		x=0;
		y++;
	}
	else if(chr>=32){
		videomem[x+y*80] = chr | (0x7 << 8);
		x++;
	}else{
		return;
	}
	if(x>80){x=80-x; y++;}
	move_csr();
}

void puts(char* ptr){
	while(*ptr) putch(*ptr++);
}

void cls(){
	unsigned int i;
	for(i=0;i<80*50;i++) videomem[i] = 0x7 << 8;
	x=y=0;
	move_csr();
}
void cls_9060(){
	unsigned int i;
	for(i=0;i<90*60;i++) videomem[i] = 0x7 << 8;
	x=y=0;
	move_csr();
}
void puti(unsigned int n, unsigned int base){
	 if (n == 0)
    {
         putch('0');
        return;
    }

    int acc = n;
    char c[32];
    int i = 0;
    while (acc > 0)
    {
        c[i] = '0' + acc%10;
        acc /= 10;
        i++;
    }
    c[i] = 0;

    char c2[32];
    c2[i--] = 0;
    int j = 0;
    while(i >= 0)
    {
        c2[i--] = c[j++];
    }
    puts(c2);
}

void put(unsigned char* t, unsigned int len){
	asm volatile("cli");
	int i;
	for(i=0;i<len;i++) putch(t[i]);
	asm volatile("sti");
}
